// Phantomas en el Museo
// Copyleft 2012 Mojon Twins

#include <spritepack.h>
//#include "debugame.h"

#pragma output STACKPTR=61952
#define AD_FREE			60020
#define VIEWPORT_X		1
#define VIEWPORT_Y		0

// Globals

struct sp_UDK keys;										// Keys structure.
void *joyfunc;											// Controls.
void *my_malloc(uint bytes) {return sp_BlockAlloc(0);}	// malloc routines
void *u_malloc = my_malloc;								// I wonder what
void *u_free = sp_FreeBlock;							// those do...
struct sp_SS *sp_player;								// Player sprites
struct sp_SS *sp_moviles [3];							// Enemy sprites
struct sp_Rect spritesClipValues;						// Clipping values
struct sp_Rect *spritesClip;							// Clipping rectangle
extern char asm_number[1];
extern unsigned int asm_int [1];
extern unsigned int asm_int_2 [1];
extern unsigned int seed [1];
unsigned char half_life;
unsigned int key_r;
unsigned char enoffs;
unsigned char objects [5];
unsigned char x_pant, y_pant;

#asm
._asm_number 
	defb 0
._asm_int
	defw 0
._asm_int_2
	defw 0
._seed	
	defw 0
#endasm

// Aburrumunialment.

// Veamos...

#include "aplib.h"
#include "pantallas.h"
#include "mapa.h"
#include "enems.h"
#include "tileset.h"
#include "sprites.h"
#include "auxiliares.h"
#include "levelstruct.h"
#include "beeper.h"
#include "final.h"
#include "engine.h"

void main (void) {
	unsigned char *allpurposepuntero;
	int j;
	unsigned char i, key, f_win;
	
	// Just randomize everything a little bit using frames.
	
	#asm
		ld	a, (23672)		; FRAMES lsb.
		ld	hl, _seed
		ld	(hl), a
	#endasm
		
	// ISR just does nothing...
	
	#asm
		di
	#endasm	
	
	sp_InitIM2(0xf1f1);
	sp_CreateGenericISR(0xf1f1);
		
	#asm
		ei
	#endasm
	// Pff
	
	sp_Initialize (7, 0);
	sp_Border (BLACK);
	sp_AddMemory(0, 56, 14, AD_FREE);
	
	// Keys
	
	keys.up    = sp_LookupKey('q');
	keys.down  = sp_LookupKey('a');
	keys.left  = sp_LookupKey('o');
	keys.right = sp_LookupKey('p');
	keys.fire  = sp_LookupKey(' ');
	key_r = sp_LookupKey ('r');

	// Load tileset
		
	allpurposepuntero = tileset;
	for (j = 0; j <= 255; j++) {
		sp_TileArray (j, allpurposepuntero);
		allpurposepuntero += 8;
	}
	
	// Clipping rectangle

	spritesClipValues.row_coord = VIEWPORT_Y;
	spritesClipValues.col_coord = VIEWPORT_X;
	spritesClipValues.height = 20;
	spritesClipValues.width = 30;
	spritesClip = &spritesClipValues;
	
	// Create sprites
	
	sp_player = sp_CreateSpr (sp_MASK_SPRITE, 3, sprite_1_a, 1, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_1_b, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_1_c, TRANSPARENT);
	player.current_frame = player.next_frame = sprite_1_a;
	
	for (i = 0; i < 3; i ++) {
		sp_moviles [i] = sp_CreateSpr(sp_MASK_SPRITE, 3, sprite_9_a, 2, TRANSPARENT);
		sp_AddColSpr (sp_moviles [i], sprite_9_b, TRANSPARENT);
		sp_AddColSpr (sp_moviles [i], sprite_9_c, TRANSPARENT);	
		en_an [i].current_frame = en_an [i].next_frame = sprite_9_a;
	}
	
	// Dummy
	while (1)  {
		sp_UpdateNow ();
		#asm
			ld	hl, _main_frame
			ld	de, $4000
			call depack
			call 59000
		#endasm
			
		joyfunc = 0;
		while (!joyfunc) {
			key = sp_GetKey ();
			if (key == '1') {
				joyfunc = sp_JoyKeyboard;
			} else if (key == '2') {
				joyfunc = sp_JoySinclair1;
			} else if (key == '3') {
				joyfunc = sp_JoyKempston;
			}	
		}
		
		f_win = game ();
		if (f_win) {
			final ();
		}
	}
}
